//+------------------------------------------------------------------+
//|                                                      CCIVMA3.mq4 |                                     
//+------------------------------------------------------------------+
//Revision history; 
//Initially using FX Snipers T3 CCI which uses MT4s CCI function.
//CCIVMA2 synch fix for failure on live bars. Still too slow on live bars due to multiplications.
//CCIVMA3 use MT4 CCI() instead.

#property indicator_chart_window
#property indicator_buffers   1
#property indicator_color1    Yellow
#property indicator_width1    2
//---- input parameters
extern int CCI_Period = 5;
//---- buffers
double MA[];
double cci[];//Not displayed
double MovBuffer[];//Not displayed
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MA);
   SetIndexBuffer(1,cci);
   SetIndexBuffer(2,MovBuffer);

 
//---- name for DataWindow and indicator subwindow label
   string short_name="CCIVMA3("+CCI_Period+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   //----
   SetIndexDrawBegin(0,2*CCI_Period);      
//--------- Safety overrides on user settings
   if(CCI_Period<2)CCI_Period=2;
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int   limit, i, counted_bars=IndicatorCounted();

//----      
   if (counted_bars<0) return(-1);  //MT4 Error exit.
   if(Bars<=2*CCI_Period) return(0); //MT4 do nothing exit.

   if (counted_bars==0) for(i=1;i<=2*CCI_Period;i++) //Initialize oldest bars with safe data for averaging.
   {
   MA[Bars-i]=Close[Bars-i];
   cci[Bars-i]=0;
   MovBuffer[Bars-i]=0;
   }
 
//---- last counted bar will be recounted, synch MT4 function calls.
   limit=Bars-counted_bars-1;//refills whole array from current bar backwards. 
   if(counted_bars>0) limit++;//refills the last couple of bars after each tick
   for(i=0;i<=limit;i++) MovBuffer[i]=iCCI(NULL, 0, CCI_Period, PRICE_MEDIAN, i);
   
//----main loop     
   for(i=Bars-counted_bars-1;i>=0;i--) 
   {
   cci[i] = MovBuffer[i];
   if (cci[i]<0)cci[i]=-cci[i];//Invert the negative signal.
   if (cci[i]>cci[i+1]) MA[i]=Close[i];//Ladder
   else MA[i]=MA[i+1];//HE    
   }
 

//----------   
   return(0);
  }
//+------------------------------------------------------------------+

